### 拷贝系统文件<br>
**System**：CosyOS的内核文件。<br>
**Config**：CosyOS的配置文件，包括系统配置文件和MCU配置文件。<br>
**Hook**：CosyOS已经为用户创建好了四个系统钩子函数，分别位于各自同名的C文件中，用户直接写代码即可。<br>
拷贝上述三个文件夹及其下属文件至您的工程文件夹。<br>

### 添加Group和文件<br>
打开工程，添加三个Group，分别命名为System、Config、Hook，再分别添加各个同名文件夹下的所有文件至各个Group。Config组可以有选择的添加文件，也可添加所有文件。首先添加syscfg.h，再根据您的MCU内核选择对应的MCU配置文件添加。如您使用的是51单片机，应添加mcucfg_8051.c和mcucfg_8051.h；如您使用的是Cortex-M内核，应添加mcucfg_cmx.c和mcucfg_cmx.h。<br>
![输入图片说明](images/KFLC.2.1.png)<br>
![输入图片说明](images/KFLC.2.2.png)

### 配置工程<br>
#### 8051内核

1、使用LX51扩展链接器<br>
![输入图片说明](images/KFLC.3.1.png)

2、内存模型<br>
![输入图片说明](images/KFLC.3.2.png)

3、优化级别<br>
应选择7级或8级，speed偏向于代码执行效率，size偏向于减少代码量，不要选其它级别。<br>
如代码放不下，您也不能把优化级别设置为9级，可通过删减代码或增大flash来解决。<br>
![输入图片说明](images/KFLC.3.3.png)

4、LX51杂项控制<br>
添加NOOVERLAY和REMOVEUNUSED，NOOVERLAY是必填项，REMOVEUNUSED为可选项。<br>
![输入图片说明](images/KFLC.3.4.png)

#### 80251内核

1、Target标签页<br>
CPU模式仅支持Source（251 native）。<br>
内存模型支持Small、XSmall、Large。<br>
Code Rom Size支持Large、Huge。Huge模式时，需用户自行配置Exeternal Memory。<br>
推荐勾选 4 Byte Interrupt Frame Size。<br>
![输入图片说明](images/KFLC.3.5.png)

2、HEX Format<br>
Code Rom Size为Huge时，仅支持HEX-386格式。<br>
![输入图片说明](images/KFLC.3.6.png)

3、优化级别<br>
应选择7级或8级，speed偏向于代码执行效率，size偏向于减少代码量，不要选其它级别。<br>
如代码放不下，您也不能把优化级别设置为9级，可通过删减代码或增大flash来解决。<br>
![输入图片说明](images/KFLC.3.7.png)

4、L251杂项控制<br>
添加NOOVERLAY和REMOVEUNUSED，NOOVERLAY是必填项，REMOVEUNUSED为可选项。<br>
![输入图片说明](images/KFLC.3.8.png)

5、内嵌汇编<br>
System\taskmge.c应设置内嵌汇编。<br>
![输入图片说明](images/KFLC.3.9.png)<br>
![输入图片说明](images/KFLC.3.10.png)

#### Arm内核

1、Target标签页<br>
这里需要注意一点：<br>
如果您的MCU有硬件浮点运算单元并且您需要使用它，<br>
仅需在此开启选项即可，剩下的活就交给操作系统吧，您什么都不用管了。<br>
![输入图片说明](images/KFLC.3.11.png)

2、C/C++标签页<br>
优化级别：官方现有不完全测试，O0~O3都可正常运行。<br>
C99Mode：建议勾选，这将使得一部分API应用起来更为便利。<br>
GNU扩展：为必选项，如不勾选，CosyOS将无法正常使用。<br>
![输入图片说明](images/KFLC.3.12.png)

### 系统配置<br>
打开Config\syscfg.h，这里是CosyOS的系统配置，各项设置均有详细的说明，在keil下可使用图形用户界面Configuration Wizard进行配置，如出现乱码，将文件的编码格式转换为ANSI即可解决。<br>
![输入图片说明](images/syscfg.png)

### MCU配置<br>
MCU配置分为用户定义和系统定义，用户定义是需要用户配置的，各项设置均有详细的说明，在keil下可使用图形用户界面Configuration Wizard进行配置，如出现乱码，将文件的编码格式转换为ANSI即可解决。<br>

#### 8051内核
![输入图片说明](images/mcucfg_8051.png)<br>

#### 80251内核
![输入图片说明](images/mcucfg_80251.png)<br>

#### Arm内核
![输入图片说明](images/mcucfg_cmx.png)<br>

### 堆栈配置<br>
#### 栈（STACK）
所有内核，栈需要用户自行在启动文件中配置。<br>
#### 堆（HEAP）
Arm内核，堆需要用户自行在启动文件中配置，即使您不使用动态内存分配（任务和消息队列均为静态创建、任务中也不使用动态内存分配），也必须配置足够的堆，因为在任务调度开始之前，PSP指向了堆极限（&__heap_limit）。<br>
8051内核、80251内核，没有堆的概念，与之相应的是内存池，用户需在MCU配置文件中配置。<br>
#### 可重入栈（reentrant stack）
CosyOS使用可重入栈的系统服务：<br>
1、中断中接收邮件，iRecvMail(mail, mbox);<br>
2、中断中接收消息，iRecvMsg(que);<br>
CosyOS仅有上述两个服务需要使用可重入栈（不包括51）。对于其它服务，无论各种内核都不需要可重入栈。<br>
1、8051内核，不允许使用可重入栈[IBP/PBP/XBP]。中断中接收消息，只允许在相同优先级的各个中断中调用。<br>
2、80251内核，可重入栈被编译器自动分配到栈中，用户无需额外配置。<br>
3、Arm内核，栈就是可重入栈，用户无需额外配置。<br>

### 链接文件<br>
用户在自己的各个C文件中需包含系统链接头文件os_link.h。<br>

```c
#include "..\System\os_link.h"
```

### 系统初始化
初始化寄存器、GPIO、中断、串口等工作，需在初始化钩子（\Hook\init_hook.c\void init_hook(void)）中执行。

### 创建任务
任务线程的创建，支持的API包括如下：<br>
1、创建一般任务：“uCreateTask”，<br>
2、创建定时中断任务：“uCreateTask_TimInt”，<br>
3、创建定时查询任务：“uCreateTask_TimQry”，<br>
而后直接写任务代码。<br>

### 启动任务
需在启动钩子（\Hook\start_hook.c\void start_hook(void)）中启动用户任务，支持的API包括如下：<br>
1、启动任务：“uStartTask”，<br>
2、启动任务并就绪：“uStartTask_Ready”，<br>
3、启动任务并挂起：“uStartTask_Suspend”，<br>
注意：所有系统任务、定时中断任务、定时查询任务均由CosyOS自动启动，无需用户启动。<br>

**_接下来，就让我们开始CosyOS之旅吧！_**  :star:  :star: 
