/**************************************************************************//**
 * @item     CosyOS Kernel
 * @file     os_iss.h
 * @brief    中断异步服务
 * @author   迟凯峰
 * @version  V3.3.0
 * @date     2023.07.15
 ******************************************************************************/

#ifndef __OS_ISS_H
#define __OS_ISS_H

#if SYSCFG_MCUCORE == 8051
#define WRITE_VAR_WRITE_START  os_sign_write_var_write = true
#define WRITE_VAR_WRITE_END    os_sign_write_var_write = false
#define WRITE_MBX_WRITE_START  os_sign_write_mbx_write = true
#define WRITE_MBX_WRITE_END    os_sign_write_mbx_write = false
#else
#define WRITE_VAR_WRITE_START  do{}while(false)
#define WRITE_VAR_WRITE_END    do{}while(false)
#define WRITE_MBX_WRITE_START  do{}while(false)
#define WRITE_MBX_WRITE_END    do{}while(false)
#endif

#define sWRITE_VAR_WRITE(p)	\
	WRITE_VAR_WRITE_START;	\
	vVarNode = p;	\
	WRITE_VAR_WRITE_END

#define sWRITE_MBX_WRITE(p)	\
	WRITE_MBX_WRITE_START;	\
	vMbxNode = p;	\
	WRITE_MBX_WRITE_END

extern void (_CODE_MEM_ * const _CONST_MEM_ vISV_Handler[__SVID_END__])(void _XDATA_MEM_ *);



#endif
